#ifndef __AREALINK_H__
#define __AREALINK_H__

//byK TypeDefs
typedef unsigned char uchar;
typedef signed char schar;
typedef unsigned short ushort;
typedef signed short sshort;
typedef unsigned long ulong;
typedef signed long slong;
typedef unsigned int uint;
typedef signed int sint;

#include <iostream>
#include <string>

using namespace std;

#include "constantes.h"

#include <math.h>

#include "zeru_mat.h"

#include "navegacion.h"


class AreaLink: public singleton<AreaLink>
{
 public:
  AreaLink(){};
 private:
  strLocalizacion lArea[4];
  
 public:
  void Init(strLocalizacion startLoc);
  void Assign(uchar index,strLocalizacion newLoc);
  void GoTo(uchar index);
  void OnKeyPess(unsigned char key);
  
  strLocalizacion operator [](uint index);
  strLocalizacion getAreaLink(uchar index);
};

#endif /*__AREALINK_H__*/


