//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "ConsolaChat.h"

#include "pantallaInicio.h"

// ---------------------------
ConsolaChat::ConsolaChat()
{
  x = 0.02; 
  y = 0.7;
  
  vidaText1 = 0;
  vidaText2 = 0;
  vidaText3 = 0;

  MiTexto = "";
}

// ---------------------------
void ConsolaChat::charMiTexto(char Caracter)
{
  if (Caracter == 13) // ENTER BUTTON
    {
      pantallaInicio::ME()->sendCHAT(MiTexto); // Comando de RED
      Chat("Me", MiTexto);
      MiTexto = "";
    }    
  else if (Caracter == 8)
    {
      MiTexto.substr(0,MiTexto.size()-1);
    }
  else if (Caracter>=32 && Caracter<126)
    {
      MiTexto += Caracter;
    }
}


// ---------------------------
void ConsolaChat::Dibujame()
{
  int GluTiempo = glutGet(GLUT_ELAPSED_TIME);   

   if (vidaText1 > 0)
    {
      TextServer.Escribe (CadenaText1, x, y, 6, 1, 1.0, 1.0, 0.3, (vidaText1)/8000.0);

      vidaText1 = vidaText1 - (GluTiempo - tiempoAnterior1);
      tiempoAnterior1 = GluTiempo;
    }

   if (vidaText2 > 0)
    {
      TextServer.Escribe (CadenaText2, x, y+0.02, 6, 1, 1.0, 1.0, 0.3, (vidaText2)/12000.0);

      vidaText2 = vidaText2 - (GluTiempo - tiempoAnterior2);
      tiempoAnterior2 = GluTiempo;
    }

   if (vidaText3 > 0)
    {
      TextServer.Escribe (CadenaText3, x, y+0.04, 6, 1, 1.0, 1.0, 0.3, (vidaText3)/12000.0);

      vidaText3 = vidaText3 - (GluTiempo - tiempoAnterior3);
      tiempoAnterior3 = GluTiempo;
    }

}


// ---------------------------
int ConsolaChat::Chat (string Nick, string Dialogo)
{

  if (vidaText1 <= vidaText2 && vidaText1 <= vidaText3)
    { 
      CadenaText1 = "<" + Nick + "> " + Dialogo;
      
      tiempoAnterior1 = glutGet(GLUT_ELAPSED_TIME);
      vidaText1 = 12000;
   }
 else if (vidaText2 <= vidaText3)
    {
      CadenaText2 = "<" + Nick + "> " + Dialogo;
      
      tiempoAnterior2 = glutGet(GLUT_ELAPSED_TIME);
      vidaText2 = 12000;
    }
  else
    {
      CadenaText3 = "<" + Nick + "> " + Dialogo;
      
      tiempoAnterior3 = glutGet(GLUT_ELAPSED_TIME);
      vidaText3 = 12000;
    }
  return 0;
}
