//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

// Propiedad intelentual de Solar OpenSource y sus miembros
// www.solar-opensource.org

#include "IRCcomunicaciones.h"

// ----------------------------------
bool SocketIRCDataArrivalCliente (string Cadena) { return (IRCcomunicaciones::RefMe->ConexionRecive(Cadena)); }
// ----------------------------------
void SocketIRCConectadoCliente () { IRCcomunicaciones::RefMe->ConexionConectado(); }
// ----------------------------------
void SocketIRCConectadoCliente (int iErr) { IRCcomunicaciones::RefMe->ConexionError(iErr); }
// ----------------------------------


// -----------------------------
bool IRCParida::operator==(IRCParida s2)
{
  //cout << "C OPERATOR ==" << endl;

  bool RETURN = false;

  if (getNombre() == s2.getNombre())
    {
      if(getIP() == s2.getIP())
	{
	  if (getNick() == s2.getNick())
	    {
	      RETURN = true;
	    }
	}
    }
  return RETURN;
}




// -----------------------------
void IRCCanal::addNick(IRCNickEnCanal Nick)
{
  
  bool Enlista = false;
  vector<IRCNickEnCanal>::iterator Ite; 

  for ( Ite = Nicks.begin() ; Ite != Nicks.end() ; Ite++)
    {
      if (Nick == *Ite)
	{
	  Enlista = true;
	  break;
	}
    }

  if (!Enlista)
    {
      // ZG. Agregamos uno nuevo
      Nicks.push_back(Nick);
    }
  else
    {
      // ZG. Substituimos los datos (Refrescamos)
      *Ite = Nick;
    }
}

// -----------------------------
void IRCCanal::BorraNick(IRCNickEnCanal Nick)
{
  vector<IRCNickEnCanal>::iterator Ite; 

  for ( Ite = Nicks.begin() ; Ite != Nicks.end() ; Ite++)
    {
      if (Nick == *Ite)
	{
	  Nicks.erase(Ite);
	  break;
	}
    }

}

// -----------------------------
void IRCCanal::Nick(IRCNickEnCanal Nick, IRCNickEnCanal NuevoNick)
{
  vector<IRCNickEnCanal>::iterator Ite; 

  for ( Ite = Nicks.begin() ; Ite != Nicks.end() ; Ite++)
    {  
      if (Nick == *Ite)
	{
	  (*Ite).setNick(NuevoNick.getNick());
	  break;
	}
    }
}


// -----------------------------
bool IRCCanal::operator==(IRCCanal s2)
{

  //cout << "C OPERATOR ==" << endl;

  bool RETURN = false;

  string Canal1 = getNombre();
  string Canal2 = s2.getNombre();

  if (Canal1.length() == Canal2.length())
    {
      RETURN = true;
      for (unsigned int i=0 ; i<Canal1.length()-1 ; i++)
	{
	  if (toupper(Canal1.at(i)) != toupper(Canal2.at(i)))
	    {
	      RETURN = false;
	      break;
	    }
	}
    } 
  return RETURN;
};


//////////////////////////////
void IRCcomunicaciones::ConexionConectado()
{
  cout << "Conectado al IRC!!" << endl;
  StatusIRCConectado = false;
}

//////////////////////////////
bool IRCcomunicaciones::ConexionRecive(string Cadena)
{

  Ocupado.Lock();

  bool Itera = false;

  static string Comandos = "";

  // Concatenamos
  Comandos = Comandos + Cadena;

  int fin;
  string CadenaCompleta;

  // Buscamos en return
  fin = Comandos.find("\r\n");


  // Si no lo encontramos no hacemos nada, en espera de que lleguen mas datos.
  if (fin == (int)string::npos) 
    {
      Ocupado.UnLock();
      return true;
    }


  // Si encontramos un Fin de linea o return, cortamos hasta encontrar el return
  CadenaCompleta = Comandos.substr(0, fin+2);

  // Y el resto lo dejamos para la siguente.
  Comandos = Comandos.substr(fin+2);

  BufferDeComandos.push_back(CadenaCompleta);

  fin = Comandos.find("\r\n");
  Itera = fin != (int)string::npos;

  Ocupado.UnLock();


  // MOVER ESTE CODIGO de Aqui; !!TODO !!
  srand(glutGet(GLUT_ELAPSED_TIME));
  int static TMP = 0; TMP++;
  if (StatusIRCConectado == false)
    {
      sendUSER("guest", "War3D", "War3D", "War3D http://war3d.solar-opensource.org");
      sendNICK("W3D" + zitoa(rand()%1000000));
    }



  if (Itera) ConexionRecive("");

  getEventos();

  return true;
}

//////////////////////////////
void IRCcomunicaciones::getEventos()
{
  bool ComandoSoportado;

  Ocupado.Lock();

  vector<string>::iterator Com;
  vector<comIRCComandoBASE*>::iterator Ite;

  for (Com = BufferDeComandos.begin(); Com != BufferDeComandos.end() ; Com++)
    {
      ComandoSoportado = false;

      for (Ite = comComandos.begin(); Ite != comComandos.end(); Ite++)
	{
	  if ((*Ite)->Accion(*Com))
	    {
	      ComandoSoportado = true;

	      cout << endl << "Comando: " << *Com;

	      break;
	   
	    }
	}
      if (!ComandoSoportado)
	{
	  cout << endl << "Comando: " << *Com;
	}
    }



  BufferDeComandos.clear();

  Ocupado.UnLock();

}


//////////////////////////////////
//////  VARIABLES ESTATICAS //////
//////////////////////////////////

IRCcomunicaciones *IRCcomunicaciones::RefMe = NULL;

///////////////////////
//////  METODOS  //////
///////////////////////


IRCcomunicaciones::IRCcomunicaciones()
{

  RefMe = this;
   
  char TMP[256]; sprintf(TMP, "BufferDeComandos[%d]", (int)this);
  Ocupado.Create(TMP);


  // Le decimod a que funcion hay que llamar cuando ocurra el evento Recibe
  IRCClienteSocket.setOnDataArrival(SocketIRCDataArrivalCliente);
  // Le decimod a que funcion hay que llamar cuando ocurra el evento Connect
  IRCClienteSocket.setOnConnect(SocketIRCConectadoCliente);
  IRCClienteSocket.setOnError(SocketIRCConectadoCliente);

  IRCClienteSocket.setLag(0);

  // Agregamos los comandos.

  comComandos.push_back(new comIRCComandoNUEVAPARTIDA((void*)this));
  comComandos.push_back(new comIRCComando001((void*)this));  
  comComandos.push_back(new comIRCComandoPING((void*)this));
  comComandos.push_back(new comIRCComandoCONEXION((void*)this));
  comComandos.push_back(new comIRCComandoMSG_PRIVADO((void*)this));
  comComandos.push_back(new comIRCComandoMSG_CANAL((void*)this));
  comComandos.push_back(new comIRCComandoJOIN_YO((void*)this));
  comComandos.push_back(new comIRCComandoJOIN_OTRO((void*)this));
  comComandos.push_back(new comIRCComandoLISTA_DE_NICKS((void*)this));
  comComandos.push_back(new comIRCComandoPART((void*)this));
  comComandos.push_back(new comIRCComandoQUIT((void*)this));
  comComandos.push_back(new comIRCComandoNICK((void*)this));
  comComandos.push_back(new comIRCComandoMIIP((void*)this));
  comComandos.push_back(new comIRCComandoERROR((void*)this));

}

//////// CONECTAR ///////////
void IRCcomunicaciones::Conectar(string Server)
{
  strServer = Server;
  IRCClienteSocket.Connect(strServer, IRCPuerto);  
}


void IRCcomunicaciones::ConexionError(int iErr)
{
  switch(iErr)
    {
    case 2004:
      {
	onNOCONEXION();
	break;
      }
    }
}


//////////////////////////////
///////// ACCIONES ///////////
//////////////////////////////

/// USER ///
/* Comando: USER 
Parámetros: <nombre de usuario> <nombre de host>
            <nombre de servidor> <nombre real>
El mensaje USER se usa al principio de cada conexión para indicar
el nombre de usuario, de host y servidor y el nombre real del nuevo
usuario. 
Referencia:  http://www.bossma.com/download/manuales/protocolo_irc.htm */
void IRCcomunicaciones::sendUSER(string Nombre, string Host, string Servidor, string NombreReal)
{
  IRCClienteSocket.Send("USER " + Nombre + " " + Host + " " + Servidor + " :" + NombreReal + "\r\n");
  cout << string("[Send:] ") + "USER " + Nombre + " " + Host + " " + Servidor + " :" + NombreReal + "\r\n";
}



/// NICK ///      
/* Comando: NICK
Parámetros: <nick>
El mensaje de NICK se usa para darle al usuario un nick o cambiar el
anterior. 
Referencia:  http://www.bossma.com/download/manuales/protocolo_irc.htm */
void IRCcomunicaciones::sendNICK(string Nick)
{
  IRCClienteSocket.Send("NICK " + Nick + "\r\n");
  cout << string("[Send:] ") + "NICK " + Nick + "\r\n";
}



/// PONG ///
/* Comando: PONG
Parametos <Numero>
El mensaje de PONG es la respuesta al mensaje de PING. */
void IRCcomunicaciones::sendPONG(string Numero)
{
  IRCClienteSocket.Send("PONG " + Numero + "\r\n");
  cout << string("[Send:] ") + "PONG " + Numero + "\r\n";
}


// ----------------------------------------
/// JOIN ///
/* Comando: JOIN
Parámetros: <canal>
Para crear un nuevo canal o formar parte de uno existente, un
usuario debe UNIRSE (JOIN) al canal. Si el canal no existe antes de
unirse, se crea y el creador del canal pasa a ser operador de canal.
Referencia:  http://www.bossma.com/download/manuales/protocolo_irc.htm */
void IRCcomunicaciones::sendJOIN(string Canal)
{
  IRCClienteSocket.Send("JOIN " + Canal + "\r\n");
  cout << string("[Send:] ") + "JOIN " + Canal + "\r\n";
}

// ----------------------------------------
/// PRIVMSG ///
/* Comando: PRIVMSG
Parametros <Mensaje>*/
void IRCcomunicaciones::sendMENSAJE(string Canal, string Mensaje)
{
  IRCClienteSocket.Send("PRIVMSG " + Canal + " :" + Mensaje + "\r\n");
  cout << string("[Send:] ") + "PRIVMSG " + Canal + " :" + Mensaje + "\r\n";
}


// ----------------------------------------
/// NUEVAPARTIDA ///
/* Comando: NUEVAPARTIDA
Parametros <Mensaje>*/
void IRCcomunicaciones::sendNUEVAPARTIDA(string Nombre, int Sockets, string Mapa)
{
  IRCClienteSocket.Send("PRIVMSG " + string(CanalWar3D) 
			+ " :" + "W3DPartida " 
			+ Nombre + "&" 
			+ getMiIP() + "&" 
			+ getIPSocket() + "&" 
			+ zitoa(Sockets) + "&" 
			+ Mapa + "&"
			+ WarVersion + "\r\n");
  
  
  cout << string("[Send:] ") + "PRIVMSG " + CanalWar3D 
    + " :" + "W3DPartida " 
    + Nombre + "&" 
    + getMiIP() + "&" 
    + getIPSocket() + "&" 
    + zitoa(Sockets) + "&" 
    + Mapa + "&"
    + WarVersion + "\r\n";


}


// ----------------------------------------
/// QUIT ///
/* Comando: QUIT
Parámetros: <mensaje>*/
void IRCcomunicaciones::sendQUIT()
{
  IRCClienteSocket.Send(string("QUIT") + " :WAR3D (Juego de estrategia 3D) http://war3d.solaropensource.org" + "\r\n");
  cout << string("[Send:] ") + "QUIT" + "\r\n";
}


// ----------------------------------------
void IRCcomunicaciones::sendGETIP()
{
  IRCClienteSocket.Send(string("WHO ") + MiNick + "\r\n");
  cout << string("[Send:] ") + "WHO " + MiNick + "\r\n";
}


// INFORMACION


// ----------------------------------------
string IRCcomunicaciones::getMiNick()
{
  return MiNick;
}


// ----------------------------------------
void IRCcomunicaciones::NuevoCanal(string Canal)
{
  // TODO Verificar que no este repetido.
  IRCCanal NuevoCanal;
  NuevoCanal.setNombre(Canal);

  Canales.push_back(NuevoCanal);
}

// ----------------------------------------
void IRCcomunicaciones::QuitNick(IRCNickEnCanal Nick)
{
  for (vector<IRCCanal>::iterator Ite = Canales.begin(); Ite != Canales.end(); Ite++)
    {
      Ite->BorraNick(Nick);
    }
}


// ----------------------------------------
void IRCcomunicaciones::Nick(IRCNickEnCanal Nick, IRCNickEnCanal NuevoNick)
{
  for (vector<IRCCanal>::iterator Ite = Canales.begin(); Ite != Canales.end(); Ite++)
    {
      Ite->Nick(Nick, NuevoNick);
    }
  if (Nick.getNick() == MiNick)
    {
      MiNick = NuevoNick.getNick();
    }
}


// ----------------------------------------
vector<IRCCanal>::iterator IRCcomunicaciones::getCanal(string Canal)
{
  IRCCanal TMP;
  TMP.setNombre(Canal);

  vector<IRCCanal>::iterator RETURN = (vector<IRCCanal>::iterator)NULL;

  for (vector<IRCCanal>::iterator Ite = Canales.begin(); Ite != Canales.end(); Ite++)
    {
      if (*Ite == TMP)
	{
	  RETURN = Ite;
	  break;
	}
    }
  return RETURN;
}
