
// By Capiflash

#ifndef _LOGGER_H_ 
#define _LOGGER_H_ 


// --** Includes: **--------------------------------------------------- 
#include <stdio.h> 

// --** Defines: **---------------------------------------------------- 
#define DEFAULT_LOG_FILENAME "log.txt" 
#define MAX_LOG_ENTRY_SIZE 256 

// --** Externals: **-------------------------------------------------- 

// --** Classes: **---------------------------------------------------- 
class Logger { 
protected: 
        FILE *f; 
        char *filename; 
        bool valid; 
         
public: 
        Logger(const char *fname=DEFAULT_LOG_FILENAME); 
        ~Logger(); 
        bool isValid() const; 
         
        void log(const char *format, ...) const; 
        void logLn(const char *format, ...) const; 
        void newline() const; 
}; 


// --** Static Methods: **--------------------------------------------- 


#endif 
