// Solar3DWidGets (c) Solar-OpenSource

// Solar3DWidGets (c) Solar-OpenSource



//***************************************************************

//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=

//*

//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D

//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.

//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.

//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.

//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org

//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.

//*  6.- No debe distribuirse el ejecutable sin el código fuente.

//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.



// Solar3DWidGets (c) Solar-OpenSource

// Solar3DWidGets (c) Solar-OpenSource





#include "Solar3DWidGetEntorno.h"





Solar3DWidGetContenedorPrimario::Solar3DWidGetContenedorPrimario()

  :Solar3DWidGetBase()

{

  izq = 0.0;           

  arriba = 0.0;         

  ancho = 1.0;         

  alto = 1.0; 

}









// ---------------------------------------------------------

Solar3DWidGetEntorno::Solar3DWidGetEntorno()

{

  // Singleton     ZG: ODIO Windows y VC++

  ContenedorPrimario = new Solar3DWidGetContenedorPrimario;

  ContenedorPrimario->Nombre = "Entorno";

}





// ---------------------------------------------------------

void Solar3DWidGetEntorno::render()

{

  miVistaGL.setVista(VistaGL_Ortogonal);

  ContenedorPrimario->render();

}





// ---------------------------------------------------------

void Solar3DWidGetEntorno::resize(int x, int y)

{

  PantallaX = x;

  PantallaY = y;

}





// ---------------------------------------------------------

void Solar3DWidGetEntorno::mouseEventosClic(int x, int y, int boton)

{



  float X = (float)x / PantallaX;

  float Y = (float)y / PantallaY;



  Solar3DWidGetMensaje_MouseClic *NuevoMensajeClic = new Solar3DWidGetMensaje_MouseClic(boton, X, Y);

  ContenedorPrimario->conector(NuevoMensajeClic);

}





void Solar3DWidGetEntorno::mouseEventosDobleClic(int x, int y, int boton)

{

  float X = (float)x / PantallaX;

  float Y = (float)y / PantallaY;



  Solar3DWidGetMensaje_MouseDobleClic *NuevoMensajeDobleClic = new Solar3DWidGetMensaje_MouseDobleClic(boton, X, Y);

  ContenedorPrimario->conector(NuevoMensajeDobleClic);

}



// ---------------------------------------------------------

void Solar3DWidGetEntorno::mouseEventosMove(int x, int y)

{



  float X = (float)x / PantallaX;

  float Y = (float)y / PantallaY;



  MouseX = X;

  MouseY = Y;



  Solar3DWidGetMensaje_MouseMove *NuevoMensajeMove = new Solar3DWidGetMensaje_MouseMove(X, Y);

  ContenedorPrimario->conector(NuevoMensajeMove);



}



// ---------------------------------------------------------

void Solar3DWidGetEntorno::mouseEventosDragAndDrop(int x, int y, int xorigen, int yorigen, int boton)

{

  

  float X = (float)x / PantallaX;

  float Y = (float)y / PantallaY;



  MouseX = X;

  MouseY = Y;



  float Xorigen = (float)xorigen / PantallaX;

  float Yorigen = (float)yorigen / PantallaY;



  Solar3DWidGetMensaje_MouseDragAndDrop *NuevoMensajeDragAndDrop = new Solar3DWidGetMensaje_MouseDragAndDrop(boton, X, Y, Xorigen, Yorigen);

  ContenedorPrimario->conector(NuevoMensajeDragAndDrop);



}





// ---------------------------------------------------------

void Solar3DWidGetEntorno::keysEventosPress(const char key)

{

  Solar3DWidGetMensaje_KeyPress * NuevoMensajeKeyPress = new Solar3DWidGetMensaje_KeyPress(key);

  ContenedorPrimario->conector(NuevoMensajeKeyPress);

}

