//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#ifndef __constantes_h__
#define __constantes_h__

#include <iostream>
#include <string>
#include <stdlib.h>

using namespace std;

// Densidad de la maya que forma el terreno
#define	Densidad 4.0

// Densidad de la maya de seleccion
#define DenSelect 4

// Desnivel de terreno, valores pequeos dan un desnivel mayor.
// un valor muy grande hara casi plano el terreno.
#define Desnivel 255.0

// Activa el uso de KStar en lugar de AStar para la IA
// Si la linea esta comenta dase usara Astar, 
// si no esta comentada se usara KStar
// #define UsaKstar

// Version del War
#define WarVersion "0.08.90"

#define W3DDedicadoPuerto 6300

// Usar opeglut en lugar de glut
// #define UsarOpenglut
// Usar opeglut en lugar de glut
// #define UsarFreeglut

#define pModoNulo                 -1
#define pModoInicio              000
#define pModoPartida             001
#define pModoJuego               100
#define pModoMenu                101
#define pModoMultiplayer         102
#define pModoNuevaPartida        201
#define pModoClienteP2P          301
#define pModoServerP2P           401


#define servidorirc    "localhost"

#ifdef UsarOpenglut
#include <GL/openglut.h>
#else
#ifdef UsarFreeglut
#include <GL/freeglut.h> 
#else
#include <GL/glut.h>	
#endif
#endif


// DEBUGUEO

// Modo debug de librerias SolarSockets
// #define SolarSocketsDebug

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


//--------


void War3DError(string Modulo, string Mensaje);
void War3DWarning(string Modulo, string Mensaje);
void War3DAccion(string Modulo, string Mensaje);
void War3DSubAccion(string Modulo, string Mensaje);
void zSleep(int Pausa);

string zitoa (int Numero);
string zitoa (float Numero);


//---------
template <class T> class Singleton : public T 
{
 private:

  Singleton(const Singleton& fact) {     }
  Singleton& operator = (const Singleton& fact) {     }
 public:
  Singleton() {     }
  ~Singleton() {     }
 public:
  static Singleton& Instance() 
    { 
      static Singleton s_instance; 
      return s_instance;
    }
};

#endif
