//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#ifndef __eventos_h__
#define __eventos_h__

#define zTipoReal 0
#define zTipoMapa 1
#define zTipoPanel 2

#include <iostream>
#include <string>

using namespace std;

#include "singleton.h"

#include "constantes.h"

#include <stdio.h>

#include <math.h>

#include "ejercito.h"

#include "zeru_mat.h"
#include "efectos.h"

#include "ConsolaChat.h"

#include "configuracion.h"

#include "SinglePlayer.h"

#include "PanelDeComandos.h"
#include "PanelDeMiniFotos.h"
#include "PanelDeEstado.h"
#include "PanelDeMiniMapa.h"

#include "oCursor.h"

class Eventos: public singleton <Eventos>
{

public:
  Eventos();


private:

  int MODO;
  int pModoAnterior;

private:

  Texto TextServer;
  VistaGL miVistaGL;

  oCursor MouseCorsor;

 public:
  PanelDeComandos ElPanelDeComandos;
  PanelDeMiniFotos ElPanelDeMiniFotos;
  PanelDeEstado ElPanelDeEstado;
  PanelDeMiniMapa ElPanelDeMiniMapa;

 private:

  int Seleccionados;
    
  FX_Seleccion *Selecionador;
  FX_BarraEnergia *Barra;
  FX_ClicEnTerreno * ClicEnTerrenoFX;

 public:
  FX_ClicEnEnemigo * ClicEnEnemigoFX;

 public:
  TextoTemporal * Anuncios01; // !! TODO !! putAnuncio(string)
  TextoTemporal * Anuncios02;
 private:
 
  ServidorDeSprites Explosion;

  float altura;

  int timeOld;

  float Retardo;
  public: float DiosAltura;  private: // !!TODO!!
  float Zoom;
  public: float	ZoomZ;  private: // !!TODO!!
  float fps; 
 
  float Lejania;


  int PanelActivo;
  
 public:

  bool SoyAdmin;
  bool Cargando;

  // --------- Funciones de Incicializacion ------

  ~Eventos();
  void Inicia ();
  

  // -------------Funciones de Render-------------

  void Render();
  void Draw(bool selecciontierra, bool seleccionbichos);

  void DubujaMouse();
  void DibujaLuces();
  void DibujaEjercitos(bool selecion);
  void CuadroDeMultiSeleccion(float x1,float y1, float x2, float y2);
  void Resize(int x, int y);
  void SetRenderModo(int Modo);
  inline int getRenderModo(){return MODO;};
  inline int getRenderModoAnterior(){return pModoAnterior;};

  // ---- Funciones de Inactivida y Retardos  ----

  void Inactivo();
  void SetRetardos();


  // ------------ Funciones de Mouse  ------------


  int Mouse_dragNdrop (float x, float y, float x2, float y2, int boton);
  int Mouse_dobleClic (float x, float y, int boton);

  int Mouse_move (float x, float y);
  int Mouse_clic (float x, float y, int boton);
  int Mouse_down (float x, float y, int boton);
  int Mouse_up (float x, float y, int boton);


  // ---- Mivilizar Coliciones Disparos ETC ----
  void Seleccion(int xPos, int yPos, int x2Pos, int y2Pos, int boton);

  
  // ---- Mivilizar Coliciones Disparos ETC ----
  void Moviliza(float x, float y);
  void PathFinder();
  void Disparos();
  bool Colision(float x, float y, float r, oSoldado* Yo);
 

  // --------- Eventos de Teclado --------------
  void Teclado(unsigned char key, int x, int y);
  void TecladoS(int key, int x, int y);

};




//---------------------------------
//---------------------------------
//---------------------------------

void zGlutMouseFunc(int button, int state, int x, int y);
void zGlutMotionFunc(int x, int y);
void zGlutPassiveMotionFunc(int x, int y);
void zGlutIdleFunc();
void zGlutDisplayFunc();
void zGlutReshapeFunc(int x, int y);
void zGlutKeyboardFunc(unsigned char key, int x, int y);
void GlutKeyboardFuncS(int key, int x, int y);

// Use a global variable to check for menu stuff.
extern bool bGotoLobby;

#endif

