#ifndef __fogofwar_h__
#define __fogofwar_h__



#include <iostream>
#include <string>

using namespace std;

#include "constantes.h"



#ifdef _WIN32 // Para Windows

#include <GL/glext.h>

#else // Para linux

#define GLX_GLXEXT_PROTOTYPES

#include <GL/glx.h>
//#include <GL/glxext.h>   /// Esta linea era para fedora core 2
//#include <GL/vms_x_fix.h>

#include <GL/glext.h>

#endif


class FOGOFWAR
{
 public:

  static bool SoporteDeExtensiones;

  FOGOFWAR();
  int alto,ancho,size;
  unsigned char *mapa;
  
  void LoadFogCoordExt(void);
  void Init(int alto,int ancho);
  void Enable(void);
  void SetPoint(int x,int y,bool value);
  bool GetPoint(int x,int y);
  void SetFogCoord(int x,int y);

  bool getVisible(int x, int y);

  ~FOGOFWAR();

  void ilumina (float x, float y, float radio, int angulo);

 private:

  void MascaraCircular (int radio, char *&Mascara);

};

bool CheckExtension( char *extName );

#endif

