// D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "IRCcomandos.h"

#include "IRCcomunicaciones.h"

/////////////////////////////////
comIRCComandoBASE::comIRCComandoBASE(string Comando, void* Padre)
{ 
  strComando = Comando; 
  this->Padre = Padre;
}


/////////////////////////////////
bool comIRCComandoBASE::Accion(string Comando)
{

  // cout << "Accion: " << Comando << endl;

  vector<string> ComandoParceado;

  string Cadena(Comando);
  string TMPCadena;

  Cadena = Cadena.substr(0,Cadena.size()-2); //Quitamos el "\r\n"
  int fin;

  for (;;)
    {
      fin = Cadena.find (" ");
      if (fin != (int)string::npos)
	{
	  ComandoParceado.push_back(Cadena.substr(0, fin));
	  TMPCadena = Cadena.substr(fin+1);
	  Cadena = TMPCadena;
	}
      else
	{
	  ComandoParceado.push_back(Cadena);
	  break;
	}
    }


  //cout << "NumParser:" << ComandoParceado.size() << endl;

  return onAccion(ComandoParceado);
}




//////////// CONEXION /////////////
bool comIRCComandoNUEVAPARTIDA::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud

  if (ComandoParceado.size() > 4)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "PRIVMSG")
	{
	  // ZG: Si el mensaje no es para un canal salimos.
	  if (ComandoParceado[2].at(0) == '#')
	    {

	      string Nick;
	      string Canal;
      
	      
	      // ZG. Extraemos el Nick de quien habla
	      int fin = ComandoParceado[0].find ("!");       
	      Nick = ComandoParceado[0].substr(1, fin-1);
	      
	      // ZG. Extraemos el canal en el cual se esta hablando
	      Canal = ComandoParceado[2];

	      if (Canal == string(CanalWar3D))
		{

		  ComandoParceado[3] = ComandoParceado[3].substr(1,999);

		  if (ComandoParceado[3] == "W3DPartida")
		    {

		      vector<string> InfoPartidaParceado;

		      string Cadena;
		      
		      for (unsigned int i = 4; i < ComandoParceado.size(); i++)
			{
			  if (i == ComandoParceado.size() - 1)
			    {
			      Cadena += ComandoParceado[i];
			    }
			  else
			    {
			      Cadena += ComandoParceado[i] + " ";
			    }
			}
		      
		      string TMPCadena;
		      
		      int finInfo;
		      
		      for (;;)
			{
			  finInfo = Cadena.find ("&");
			  if (finInfo != (int)string::npos)
			    {
			      InfoPartidaParceado.push_back(Cadena.substr(0, finInfo));
			      TMPCadena = Cadena.substr(finInfo+1);
			      Cadena = TMPCadena;
			    }
			  else
			    {
			      InfoPartidaParceado.push_back(Cadena);
			      break;
			    }
			}

		      if (InfoPartidaParceado.size()==6)
			{
			  
			  cout << "|" << InfoPartidaParceado[5] << "|" << WarVersion << "|" << endl;

			  if (InfoPartidaParceado[5] == WarVersion)
			    { 

			      cout << InfoPartidaParceado[5] << endl;

			      ((IRCcomunicaciones*)Padre)->onNUEVAPARTIDA(Nick,
									  InfoPartidaParceado[0], 
									  InfoPartidaParceado[1], 
									  InfoPartidaParceado[2],
									  atoi(InfoPartidaParceado[3].c_str()), 
									  InfoPartidaParceado[4]);  
			    }
			}
		      else
			{
			  RETURN = false;
			}
		      RETURN = true;
		    }
		}	      
	    }
	}
    }
  return RETURN;
}




//////////// PING /////////////
bool comIRCComandoPING::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;

  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 1)
    {
      if (ComandoParceado[0] == "PING")
	{
	  string Numero = ComandoParceado[1].c_str()+1;
	  ((IRCcomunicaciones*)Padre)->onPING(Numero);
	  RETURN = true;
	}
    }
 return RETURN;
}


//////////// 001 /////////////
bool comIRCComando001::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 1)
    {
      if (ComandoParceado[1] == "001")
	{
	  unsigned int i;
	  string MensajeDeBienvenida;
	  
	  for (i=3 ; i<ComandoParceado.size()-1 ; i++)
	    {
	      MensajeDeBienvenida += ComandoParceado[i];
	    }
      
	  ((IRCcomunicaciones*)Padre)->on001(MensajeDeBienvenida);
	  RETURN = true;
	}
    }
 return RETURN;
}


//////////// CONEXION /////////////
bool comIRCComandoCONEXION::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 1)
    {
      if (((IRCcomunicaciones*)Padre)->StatusIRCConectado == false)
	{    
	  if (atoi(ComandoParceado[1].c_str()) > 0)
	    {
	      ((IRCcomunicaciones*)Padre)->onCONEXION(ComandoParceado[2]);
	      ((IRCcomunicaciones*)Padre)->StatusIRCConectado = true;
	       RETURN = true;
	    }
	  
	}
    }
  return RETURN;
}


//////////// CONEXION /////////////
bool comIRCComandoMSG_PRIVADO::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "PRIVMSG")
	{
      
	  // ZG: Si el mensaje es para un canal salimos.
	  if (ComandoParceado[2].at(0) != '#')
	    {
	      string Nick;
	      string Mensaje;
	      
	      // ZG. Extraemos el Nick de quien habla
	      int fin = ComandoParceado[0].find ("!");
	      Nick = ComandoParceado[0].substr(1, fin-1);
	      
	      // ZG. Extraemos el mensaje
	      for (unsigned int i = 3; i < ComandoParceado.size(); i++)
		{
		  if (i == 3 )
		    {
		      Mensaje = ComandoParceado[i].substr(1,999);
		    }
		  else
		    {
		      Mensaje += " " + ComandoParceado[i];
		    }
		}
	      
	      ((IRCcomunicaciones*)Padre)->onMSG_PRIVADO(Nick, Mensaje);

	      RETURN = true;
	    }
	}
    }
  return RETURN;
}



//////////// CONEXION /////////////
bool comIRCComandoMSG_CANAL::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "PRIVMSG")
	{
	  // ZG: Si el mensaje no es para un canal salimos.
	  if (ComandoParceado[2].at(0) == '#')
	    {


	      cout << ComandoParceado[2] << " " << ComandoParceado[3] << endl;

	      if (ComandoParceado[3] != "W3DPartida") // Palabras reservadas
		{

		  string Nick;
		  string Mensaje;
		  string Canal;
		  
		  
		  // ZG. Extraemos el Nick de quien habla
		  int fin = ComandoParceado[0].find ("!");       
		  Nick = ComandoParceado[0].substr(1, fin-1);
		  
		  // ZG. Extraemos el mensaje
		  for (unsigned int i = 3 ; i < ComandoParceado.size() ; i++)
		    {
		      if (i == 3 )
			{
			  Mensaje = ComandoParceado[i].substr(1,999);
			}
		      else
			{
			  Mensaje += " " + ComandoParceado[i];
			}
		    }
		  
		  // ZG. Extraemos el canal en el cual se esta hablando
		  Canal = ComandoParceado[2];
		  
		  ((IRCcomunicaciones*)Padre)->onMSG_CANAL(Nick, Canal, Mensaje);
		  
		  RETURN = true;
		  
		}
	    }
	}
    }
  return RETURN;
}




//////////// CONEXION /////////////
bool comIRCComandoJOIN_YO::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "JOIN")
	{

	  string Nick;
	  string Mensaje;
	  string Canal;
	  	  
	  // ZG. Extraemos el Nick de quien habla
	  int fin = ComandoParceado[0].find ("!");       
	  Nick = ComandoParceado[0].substr(1, fin-1);
	      
	  if (Nick == ((IRCcomunicaciones*)Padre)->getMiNick())
	    {      
	      // ZG. Extraemos el canal en el cual se esta hablandoal cual ha entrado el Nick
	      Canal = ComandoParceado[2].substr(2, 999);
	      
	      ((IRCcomunicaciones*)Padre)->onJOIN_YO(Canal);

	      // ZG. Insertamos un nuevo canal a la lista de canales
	      ((IRCcomunicaciones*)Padre)->NuevoCanal(Canal);	

      
	      RETURN = true;
	    }
	}
    }
  return RETURN;
}



//////////// CONEXION /////////////
bool comIRCComandoJOIN_OTRO::onAccion(vector<string> ComandoParceado)
{

  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "JOIN")
	{

	  string Nick;
	  string Mensaje;
	  string Canal;

	  // ZG. Extraemos el Nick de quien habla
	  int fin = ComandoParceado[0].find ("!");       
	  Nick = ComandoParceado[0].substr(1, fin-1);
      
	  if (Nick != ((IRCcomunicaciones*)Padre)->getMiNick())
	    {      
	      // ZG. Extraemos el canal en el cual se esta hablandoal cual ha entrado el Nick
	      Canal = ComandoParceado[2].substr(2, 999);
	      
	      // ZG. Insertamos un nuevo Nick al Canal.

	      vector<IRCCanal>::iterator ElCanal = ((IRCcomunicaciones*)Padre)->getCanal(Canal);

	      if (ElCanal != (vector<IRCCanal>::iterator)NULL)
		{
	      
		  bool Op = false;
		  bool Vos = false;
		  for (int i = 0 ; i < 2 ; i++)
		    { 
		      if (Nick.find('@') != string::npos)
			{
			  Nick = Nick.substr(1,999);
			  Op = true;
			}
		      if (Nick.find('+') != string::npos)
			{
			  Nick = Nick.substr(1,999);
			  Vos = true;
			}
		    }

		  IRCNickEnCanal NuevoNick(Nick, Op, Vos);
		  
		  ElCanal->addNick(NuevoNick);
		  ElCanal->addNick(NuevoNick);
		  ElCanal->addNick(NuevoNick);	      
		    
		}
	      else
		{
		  //TODO!! ZG. EventoError
		} 

	      ((IRCcomunicaciones*)Padre)->onJOIN_OTRO(Nick, Canal);
	      RETURN = true;
	    }
	}
    }
  return RETURN;
}


//////////// CONEXION /////////////
bool comIRCComandoLISTA_DE_NICKS::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;

 
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es lista salimos.
      if (ComandoParceado[1] == "353")
	{

	  string Nick;
	  vector<string> Nicks;
	  string Canal;

	  // ZG: Obtenemos el canal
	  Canal = ComandoParceado[4].substr(1,666);
	      
	  // ZG. Extraemos el mensaje
	  for (unsigned int i = 5 ; i < ComandoParceado.size() -1 ; i++)
	    {
	      if (i == 5 )
		{
		  Nick = ComandoParceado[i].substr(1,999);
		}
	      else
		{
		  Nick = ComandoParceado[i];
		}

	      bool Op = false;
	      bool Vos = false;
	      for (int i = 0 ; i < 2 ; i++)
		{ 
		  if (Nick.find('@') != string::npos)
		    {
		      Nick = Nick.substr(1,999);
		      Op = true;
		    }
		  if (Nick.find('+') != string::npos)
		    {
		      Nick = Nick.substr(1,999);
		      Vos = true;
		    }
		}


	      vector<IRCCanal>::iterator ElCanal = ((IRCcomunicaciones*)Padre)->getCanal(Canal);
	      
	      if (ElCanal != (vector<IRCCanal>::iterator)NULL)
		{
		  
		  IRCNickEnCanal NuevoNick(Nick, Op, Vos);
		  
		  ElCanal->addNick(NuevoNick);
		  ElCanal->addNick(NuevoNick);
		  ElCanal->addNick(NuevoNick);	      
		  
		}
	      else
		{
		  cout << "canal no creado" << endl;
		  //TODO!! ZG. EventoError
		}




	      Nicks.push_back(Nick);
	    }
	     
	  ((IRCcomunicaciones*)Padre)->onLISTA_DE_NICKS (Nicks, Canal);
	  RETURN = true;
	}
    }
  return RETURN;
}



//////////// PART /////////////
bool comIRCComandoPART::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "PART")
	{

	  string Nick;
	  string Canal;

	  // ZG. Extraemos el Nick de quien sale del canal
	  int fin = ComandoParceado[0].find ("!");       
	  Nick = ComandoParceado[0].substr(1, fin-1);


	      
	  // ZG. Extraemos el canal del cual sale
	  Canal = ComandoParceado[2].substr(1, 999);

	  vector<IRCCanal>::iterator ElCanal = ((IRCcomunicaciones*)Padre)->getCanal(Canal);

	  if (ElCanal != (vector<IRCCanal>::iterator)NULL)
	    {
	      IRCNickEnCanal TMPNick(Nick, false, false);
	      ElCanal->BorraNick(TMPNick);
	      
	      ((IRCcomunicaciones*)Padre)->onPART(Nick, Canal);

	      RETURN = true;
	    }  
	}
    }
  return RETURN;
}




//////////// QUIT /////////////
bool comIRCComandoQUIT::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "QUIT")
	{

	  string Nick;
	  string Canal;

	  // ZG. Extraemos el Nick de quien sale del canal
	  int fin = ComandoParceado[0].find ("!");       
	  Nick = ComandoParceado[0].substr(1, fin-1);
	      
	  // ZG. Extraemos el canal del cual sale
	  Canal = ComandoParceado[2].substr(1, 999);

	  IRCNickEnCanal TMPNick(Nick, false, false);

	  ((IRCcomunicaciones*)Padre)->QuitNick(TMPNick);
	  ((IRCcomunicaciones*)Padre)->onQUIT(Nick);

	  RETURN = true;
  
	}
    }
  return RETURN;
}


//////////// NICK /////////////
bool comIRCComandoNICK::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 2)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "NICK")
	{

	  string VNick;
	  string NNick;
	  string Canal;

	  // ZG. Extraemos el Nick
	  int fin = ComandoParceado[0].find ("!");       
	  VNick = ComandoParceado[0].substr(1, fin-1);

	  NNick = ComandoParceado[2].substr(1, 999);
	      
	  // ZG. Extraemos el canal del cual sale

	  IRCNickEnCanal ViejoNick(VNick, false, false);
	  IRCNickEnCanal NuevoNick(NNick, false, false);

	  ((IRCcomunicaciones*)Padre)->Nick(ViejoNick, NuevoNick);
	  ((IRCcomunicaciones*)Padre)->onNick(VNick, NNick);

	  RETURN = true;
  
	}
    }
  return RETURN;
}


//////////// MIIP /////////////
bool comIRCComandoMIIP::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;
  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 8)
    {
 
      // ZG: Si el comando no es mensaje salimos.
      if (ComandoParceado[1] == "352")
	{
	 
	  if(ComandoParceado[7] == ((IRCcomunicaciones*)Padre)->getMiNick())
	    {
	      ((IRCcomunicaciones*)Padre)->setMiIP(ComandoParceado[5]);
	    }
	}
    }
  return RETURN;
}


//////////// ERROR /////////////
bool comIRCComandoERROR::onAccion(vector<string> ComandoParceado)
{
  bool RETURN = false;

  // ZG: Checamos la longitud
  if (ComandoParceado.size() > 1)
    {
      if (ComandoParceado[0] == "ERROR")
	{
	  
	  string Mensaje;

	  // ZG. Extraemos el mensaje
	  for (unsigned int i = 1 ; i < ComandoParceado.size() ; i++)
	    {
	      Mensaje += ComandoParceado[i] + " ";
	    }

	  ((IRCcomunicaciones*)Padre)->onERROR(Mensaje);


	  RETURN = true;
	}
    }
 return RETURN;
}
